"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pnpm_default_reporter_1 = require("pnpm-default-reporter");
const silentReporter_1 = require("./silentReporter");
const streamParser_1 = require("../logging/streamParser");
const bole = require("bole");
exports.default = (reporterType) => {
    switch (reporterType) {
        case 'default':
            pnpm_default_reporter_1.default(streamParser_1.default);
            return;
        case 'ndjson':
            bole.output([
                {
                    level: 'debug', stream: process.stdout
                },
            ]);
            return;
        case 'silent':
            silentReporter_1.default(streamParser_1.default);
            return;
    }
};
//# sourceMappingURL=index.js.map