import { Got } from '../../network/got';
import { PackageSpec } from '..';
import { Package } from '../../types';
export declare type PackageMeta = {
    'dist-tag': {
        [name: string]: string;
    };
    versions: {
        [name: string]: PackageInRegistry;
    };
};
export declare type PackageInRegistry = Package & {
    dist: {
        shasum: string;
        tarball: string;
    };
};
export default function loadPkgMetaNonCached(spec: PackageSpec, opts: {
    storePath: string;
    got: Got;
    metaCache: Map<string, PackageMeta>;
    offline: boolean;
    registry: string;
}): Promise<PackageMeta>;
